import hyperdex.client
from flask import Flask, request, session, g, redirect, url_for, abort, render_template, flash
from flask.ext.wtf import Form
from wtforms import StringField, TextAreaField
from wtforms.validators import DataRequired

import uuid

#config
DEBUG = True
SECRET_KEY = 'development key'

#create a simple application
app = Flask(__name__)
app.config.from_object(__name__)
c = hyperdex.client.Client('127.0.0.1', 1982)

class PostForm(Form):
    title = StringField('title', validators=[DataRequired()])
    body  = TextAreaField('body',  validators=[DataRequired()])

@app.route('/')
@app.route('/index', methods=['POST', 'GET'])
def index():
    form = PostForm()
    cur = c.search('posts', {})
    entries = [dict(row) for row in cur]
    
    if request.method == 'POST':
        if not form.validate_on_submit():
            flash(u'Invalid Input')
            return render_template('show_entries.html', entries=entries, form=form)
        c.put('posts', str(uuid.uuid1()), {'views' : 0, 'title' : str(request.form['title']), 'body' : str(request.form['body'])})
        flash('New entry was successfully posted')
        cur = c.search('posts', {})
        entries = [dict(row) for row in cur]
        return render_template('show_entries.html', entries=entries, form=PostForm(title='', body=''))

    return render_template('show_entries.html', entries=entries, form=form)

@app.route('/login')
def login():
    return redirect(url_for('index'))

@app.route('/logout')
def logout():
    return redirect(url_for('index'))

if __name__ == '__main__':
    app.run()

